;+
; CREATECUBEOBJECT
;
; Intent:
;        Convert data cube into object to be used for finding nulls
;
; History:
;        CB, October 2006
;-

function createCubeObject, cube, xr=xr, yr=yr, zr = zr

s = size(cube)
if n_elements(xr) ne 2 then begin
    xr = [0, s[2]-1]
endif
if n_elements(yr) ne 2 then begin
    yr = [0, s[3]-1]
endif
if n_elements(zr) ne 2 then begin
    zr = [0, s[4]-1]
endif

cb = obj_new("CubeObject")
cb->setCube, cube[*,xr[0]:xr[1], yr[0]:yr[1], zr[0]:zr[1]]
;cb->setRanges, ranges
cb->setSize

return, cb

end
