;+
; CUBEOBJECT::CHECKMODIFIEDEULER
;
; Intent:
;        Determine whether modified Euler equations are satisfied
;
; History:
;        CB, October 2006.
;-

pro cubeObject::CheckModifiedEuler, twod=twod, threed=threed, imb = imb

st = self.qcpstats
if keyword_set(twod) then begin
    ; S* - P
    e2top = total(st[0,*,1]) - total(st[1,*,1])
    e2bot = total(st[0,*,0]) - total(st[1,*,0])
    if e2top ne e2bot then stop, " 2D Euler unsatisfied"
    
    return
endif
if keyword_set(threed) then begin
    ; (S*+ - P+) - (S*- - P-)2
    e3top = (st[0,0,1] - st[1,0,1]) - (st[0,1,1] - st[1,1,1])
    e3bot = (st[0,0,0] - st[1,0,0]) - (st[0,1,0] - st[1,1,0])
    imb = 0.5 * (e3top - e3bot)
    print, "Imbalance = ", imb
    ;stop
endif
end
