;+
; CUBEOBJECT::CURVE2NULLS
;
; Intent:
;        Take a curve and determine where Bz changes on it
;
; History:
;        CB, October 2006
;-

function cubeObject::myNewton, x

x = double(x)
Bmax2 = max(abs(self->getCube()))^2
count = 0
done = 0
B = self->calcField(x)
repeat begin

    J = self->calcDerivs(x)
    Ji = invert(J)
    dx = - Ji ## B
    ;if total(dx^2) gt 0.01 then begin
    ;    dx = normalise(dx) * 0.1
    ;endif
    repeat begin
        bnew = self->calcfield(x + dx)
        if total(bnew^2) lt total(b^2) then begin
            ldone = 1
        endif else begin
            ldone = 0
            dx = dx * 0.8
            if max(abs(dx)) lt 1.e-40 then begin
                ldone = 1
                done = 1
            endif
        endelse
    endrep until ldone eq 1
    x = x + dx
    ;print, x, total(b^2)/bmax2
    count = count + 1
    B = self->calcField(x)
    ;if total(B^2) lt Bmax2 * 1.e-20 then done = 1
    wf = where(finite(x) eq 0, nf)
    if count gt 10000 or self->isinbox(x) eq 0 or nf ne 0 then done = 2
endrep until done ne 0
;stop, x, sqrt(total(b^2))/sqrt(bmax2), done
if done eq 2 then return, 0 
return, x

end


function newtonfunc, x
common newt, cube
return, interpolate(cube, x[0], x[1],x[2])
end

function cubeObject::curve2nulls, curve, pts = pts
common newt, cube
cube = self->getCube()
nc = n_elements(curve[0,*])
;print, nc
if nc eq 1 then return, 0
w = where(curve[5,0:nc-2] * curve[5,1:nc-1] lt 0, n)
;print, n
if n eq 0 then return, 0

z1 = rebin(curve[5,w],6,n)
z2 = rebin(curve[5,w+1],6,n)

pt = (-z1 * curve[*, w] + z2 * curve[*, w+1]) / (z2-z1)
p1 = [0.,0.,0.]
out = 0
for i =0, n - 1 do begin
    ;print, pt[0:2,i]
    pti = self->myNewton(pt[0:2,i])
    ;print, pti
    ;pti = newton(pt[0:2, i], 'newtonfunc')
    ;print, pti
    if n_elements(pti) eq 3 then begin
        p1 = [[p1],[pti]]
        out = out + 1
    endif
endfor
if out eq 0 then return, 0
pts = p1[*,1:*]
;stop, pts
return, out
end
