;+
; CUBEOBJECT::REVERTTOBOXCOORDS
;
; Intent:
;        Take a surface-point and put the missing dimension back in
;
; History:
;        CB, October 2006
;-

function cubeObject::RevertToBoxCoords, cp, top=top, bottom=bottom, left=left, $
              right = right, front = front, back = back, $
              ncross = ncross

qcps = fltarr(3, ncross)

case 1 of
    keyword_set(top): begin
        qcps[[0,1],*] = cp
        qcps[2,*] = self.size[2]-1
    end
    keyword_set(bottom): begin
        qcps[[0,1],*] = cp
        qcps[2,*] = 0.
    end
    keyword_set(left): begin
        qcps[[1,2],*] = cp
        qcps[0,*] = 0
    end
    keyword_set(right): begin
        qcps[[1,2],*] = cp
        qcps[0,*] = self.size[0]-1
    end
    keyword_set(front): begin
        qcps[[0,2],*] = cp
        qcps[1,*] = 0
    end
    keyword_set(back): begin
        qcps[[0,2],*] = cp
        qcps[1,*] = self.size[1]-1
    end
endcase

return, qcps

end
