;+
; CUBEOBJECT::UPDATEQCPSTATS
;
; Intent:
;        Update the QCP stats. What did you expect?
;
; Notes:
;        QCP stats are a 2x2x2 array. The first element corresponds to
;        source(0)/prone nulls, the second to +ve(1)/-ve and the third 
;        to top(1)/bottom.
;-

pro cubeObject::UpdateQCPStats, q

case q->getChar() of
    "S": out = [0]
    "P": out = [1]
    else: stop
endcase
case q->getSign() of 
    +1: out = [out, 1]
    -1: out = [out, 0]
endcase
case q->getSurf() of
    2: out = [out, 1]
    1: out = [out, 0]
    else: stop
endcase
;print, q->getpos(), q->getchar(), q->getsign(), q->getsurf()

self.qcpstats[out[0],out[1],out[2]] = self.qcpstats[out[0],out[1],out[2]] + 1
;stop, out, self.qcpstats
end 


