;+
; DERIVATIVEMAGIC
;
; Intent:
;        Smooth the derivatives to avoid falling into the gaps
;
; History:
;        CB, October 2006
;-

function d3magic, b1, b2, b3, dx

mi = [[-dx, 2*dx, -dx], [-dx^2,0,dx^2],[0,-2*dx^3,0]] / (-2 * dx^3)

mat = ([[b1],[b2],[b3]])
;stop, mi, mat
abc = mi ## mat

return, (abc[*,1])

end


function derivativeMagic, b, bxp, bxm, byp, bym, bzp, bzm, dx

r1 = d3magic(bxp, b, bxm,dx)
r2 = d3magic(byp, b, bym,dx)
r3 = d3magic(bzp, b, bzm,dx)

return, transpose([[r1],[r2],[r3]])

end
