;+
; NORMALISE
;
; Intent:
;        Take in x and return xhat. And |x| if you want it.
; 
; Usage:
;        xhat = normalise(x, md = modx)
;
; Input:
;        x: A vector to normalise
; 
; Output:
;        xhat: A normalised vector
;        modx: |x|
;
; History:
;        Winter 05/06, CB
;        Spruced up March 06, CB
;-



function normalise, vec, md = d
d = (sqrt(transpose(vec^2) # [1,1,1]))[0]

return, vec / d
end

pro normtest, n1, n2, m1, m2
profiler, /reset
profiler, /system
profiler
;x = findgen(3,100)
x = [1,2,3.]
n1 = normalise(x, md=m1)
n2 = normalise2(x, md=m2)
profiler, /report
end
